'use strict';

var utils = require('../utils/writer.js');
var Ad = require('../service/AdService'); // Assurez-vous d'importer le service Announcement
var User = require('../service/UserService');

module.exports.addAd = function addAd (req, res, next, body) {
    const token = req.headers.authorization.split(' ')[1];
    Ad.addAd(body, token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (response) {
            utils.writeJson(res, response);
        });
};

module.exports.updateAd = function updateAd (req, res, next) {
    const token = req.headers.authorization.split(' ')[1];
    Ad.updateAd(req.openapi.pathParams.id, req.body, token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (response) {
            utils.writeJson(res, response);
        });
};

module.exports.deleteAd = function deleteAd(req, res, next, announcementId) {
    const token = req.headers.authorization.split(' ')[1];
    Ad.deleteAd(announcementId, token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (response) {
            utils.writeJson(res, response);
        });
};

module.exports.getAds = function getAnnouncements(req, res) {
    const token = req.headers.authorization.split(' ')[1];

    Ad.getAds(token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (error) {
            res.status(500).json({ message: error.message });
        });
};

module.exports.getAdById = function getAnnouncementById(req, res) {
    const announcementId = req.openapi.pathParams.id;
    const token = req.headers.authorization.split(' ')[1];

    Ad.getAdById(announcementId, token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (error) {
            res.status(500).json({ message: error.message });
        });
};

exports.askQuestion = async function(req, res) {
    const announcementId = req.openapi.pathParams.id;
    const { question } = req.body;
    const token = req.headers.authorization.split(' ')[1];

    Ad.askQuestion(announcementId, question, token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (error) {
            res.status(500).json({ message: error.message });
        });
};

exports.answerQuestion = async function(req, res) {
    const announcementId = req.openapi.pathParams.id;
    const questionId = req.openapi.pathParams.questionId;
    const { answer } = req.body;
    const token = req.headers.authorization.split(' ')[1];

    Ad.answerQuestion(announcementId, questionId, answer, token)
        .then(function (response) {
            utils.writeJson(res, response);
        })
        .catch(function (error) {
            res.status(500).json({ message: error.message });
        });
};